From 0431fc7de415ce8e25d60819f068d55c17e5aff1 Mon Sep 17 00:00:00 2001
From: David Carlos <ddavidcarlos1392@gmail.com>
Date: Mar 16 2018 02:30:30 +0000
Subject: [PATCH 14/17] Fix logging messages.


---

diff --git a/kiskadee/fetchers/__init__.py b/kiskadee/fetchers/__init__.py
index b61511b..21a6fd6 100644
--- a/kiskadee/fetchers/__init__.py
+++ b/kiskadee/fetchers/__init__.py
@@ -49,12 +49,8 @@ class Fetcher(abc.ABC):
         if not project:
             raise NotImplementedError('fetcher must call parent watch method ')
 
-        kiskadee.queue.Queues().enqueue_project(project)
-        fetcher = project['fetcher']
-        kiskadee.logger.debug(
-                "{} fetcher: sending package {}_{} for monitor"
-                .format(fetcher, project['name'], project['version'])
-            )
+        fetcher = project['fetcher'].split('.')[-1]
+        kiskadee.queue.Queues().enqueue_project(project, fetcher)
 
     @abc.abstractmethod
     def compare_versions(self, new, old):
diff --git a/kiskadee/monitor.py b/kiskadee/monitor.py
index 1996a0b..58f1493 100644
--- a/kiskadee/monitor.py
+++ b/kiskadee/monitor.py
@@ -23,20 +23,20 @@ class Monitor:
         Analyzer.create_analyzers(self.db)
 
     def run(self):
-        kiskadee.logger.debug('Monitor PID: {}'.format(os.getpid()))
+        kiskadee.logger.debug('MONITOR PID: {}'.format(os.getpid()))
 
         for fetcher in kiskadee.load_fetchers():
             thread = Monitor._start_fetcher(fetcher.Fetcher().watch)
 
         while RUNNING:
+            kiskadee.logger.debug('MONITOR STATE: Idle'.format(os.getpid()))
             new_project = self.dequeue_project_from_fetchers()
             self.send_project_to_runner(new_project)
             analyzed_project = self.dequeue_analysis_from_runner()
             self.save_analyzed_project(analyzed_project)
 
     def dequeue_project_from_fetchers(self):
-        new_project = self.queues.dequeue_project()
-        return new_project if new_project else {}
+        return self.queues.dequeue_project()
 
     def dequeue_analysis_from_runner(self):
         return self.queues.dequeue_result()
@@ -45,10 +45,12 @@ class Monitor:
         if data:
             fetcher, project = self.get_fetcher_and_project(data)
             data["fetcher_id"] = fetcher.id if fetcher else ''
-            if not project:
-                self.queues.enqueue_analysis(data)
-            elif self.is_a_new_project_version(project, data):
-                self.queues.enqueue_analysis(data)
+            if not self.is_a_new_project_version(project, data):
+                kiskadee.logger.debug('MONITOR STATE: Project {} already'\
+                        'analyzed'.format(data['name']))
+                return
+            self.queues.enqueue_analysis(data)
+
 
     def get_fetcher_and_project(self, data):
         fetcher_name = data['fetcher'].split('.')[-1]
@@ -58,10 +60,13 @@ class Monitor:
         return fetcher, project
 
     def is_a_new_project_version(self, project, data):
-        project_version = data['version']
-        analysed_version = project.versions[-1].number
-        fetcher = importlib.import_module(data['fetcher']).Fetcher()
-        fetcher.compare_versions(project_version, analysed_version)
+        if project:
+            project_version = data['version']
+            analysed_version = project.versions[-1].number
+            fetcher = importlib.import_module(data['fetcher']).Fetcher()
+            return fetcher.compare_versions(project_version, analysed_version)
+        else:
+            return True
 
     def save_analyzed_project(self, data):
         if not data:
diff --git a/kiskadee/queue.py b/kiskadee/queue.py
index 672958a..bbb7128 100644
--- a/kiskadee/queue.py
+++ b/kiskadee/queue.py
@@ -4,34 +4,6 @@ from multiprocessing import Queue
 
 import kiskadee
 
-def empty_queue(func):
-    """Decorator that checks if retrieve data from a
-    queue will trigger a empty exception.
-    """
-    def wrapper(*args, **kwargs):
-        try:
-            return func(*args, **kwargs)
-        except Exception:
-            return {}
-    return wrapper
-
-def enqueue_project(fetcher_watch):
-    """Decorator to be used with watch fetchers method. Every project returned
-    by the watch method, will be enqueued on the queue projects.
-    :arg1: watch method
-    :returns: a wrapper variable
-    """
-    def wrapper(*args, **kwargs):
-        project = fetcher_watch(*args, **kwargs)
-        kiskadee.queue.queues.enqueue_project(project)
-        fetcher = project['fetcher'].name
-        kiskadee.logger.debug(
-                "{} fetcher: sending package {}_{} for monitor"
-                .format(fetcher, package['name'], package['version'])
-            )
-        time.sleep(2)
-    return wrapper
-
 analysis = Queue()
 results = Queue()
 projects = Queue()
@@ -42,7 +14,7 @@ class Queues():
     @staticmethod
     def enqueue_analysis(project_to_analysis):
         """Put a analysis on the analysis queue."""
-        log_msg = "Sending project {}_{} for analysis"\
+        log_msg = "MONITOR STATE: Sending project {}-{} for analysis"\
                 .format(project_to_analysis['name'],
                         project_to_analysis['version'])
         kiskadee.logger.debug(log_msg)
@@ -52,11 +24,12 @@ class Queues():
     def dequeue_analysis():
         """Get a analysis from the analysis queue."""
         project_to_analysis = analysis.get()
+        fetcher = project_to_analysis ['fetcher'].split('.')[-1]
         kiskadee.logger.debug(
-                'RUNNER: deqeued {}-{} from {}'
+                'RUNNER STATE: dequeued {}-{} from {}'
                 .format(project_to_analysis['name'],
                         project_to_analysis['version'],
-                        project_to_analysis['fetcher'])
+                        fetcher)
             )
         return project_to_analysis
 
@@ -64,25 +37,39 @@ class Queues():
     def enqueue_result(project):
         """Put a result on the results queue."""
         kiskadee.logger.debug(
-                "RUNNER: Sending {}-{} to Monitor"
+                "RUNNER STATE: Sending {}-{} to Monitor"
                 .format(project["name"],
                         project["version"])
             )
         results.put(project)
 
     @staticmethod
-    @empty_queue
     def dequeue_result():
         """Get a result from the results queue."""
-        return results.get(timeout=1)
+        result = results.get()
+        kiskadee.logger.debug(
+                "MONITOR STATE: Pick Up analyzed project"
+                .format(result["name"],
+                        result["version"])
+            )
+        return result
 
     @staticmethod
-    def enqueue_project(project):
+    def enqueue_project(project, fetcher):
         """Put a result on the results queue."""
+        kiskadee.logger.debug(
+                "FETCHER {}: sending package {}-{} for monitor"
+                .format(fetcher, project['name'], project['version'])
+            )
         projects.put(project)
 
     @staticmethod
-    @empty_queue
     def dequeue_project():
         """Get a result from the results queue."""
-        return projects.get(timeout=1)
+        project = projects.get()
+        kiskadee.logger.debug(
+                "MONITOR STATE: Pick Up monitored project."
+                .format(project["name"],
+                        project["version"])
+            )
+        return project
diff --git a/kiskadee/report.py b/kiskadee/report.py
index 10aa7cc..1afc770 100644
--- a/kiskadee/report.py
+++ b/kiskadee/report.py
@@ -36,7 +36,6 @@ class CppcheckReport(Report):
 
     def _compute_reports(self, analyzer):
         """Compute every report type for cppcheck analyzer."""
-        print(analyzer)
         result_dict = {
                 'warning': 0,
                 'error': 0,
diff --git a/kiskadee/runner.py b/kiskadee/runner.py
index ea9ef60..d1fa040 100644
--- a/kiskadee/runner.py
+++ b/kiskadee/runner.py
@@ -1,4 +1,4 @@
-"""Run each static analyzer in each package marked for analysis."""
+"""Run each static analyzer in each project marked for analysis."""
 
 import shutil
 import tempfile
@@ -25,14 +25,13 @@ class Runner:
     def run(self):
         """Run static analyzers.
 
-        Continuously dequeue packages from `analyses_queue` and call the
-        :func:`analyze` method, passing the dequeued package.
-        After the analysis, updates the status of this package on the database.
+        Continuously dequeue projects from `analyses_queue` and call the
+        :func:`analyze` method, passing the dequeued project as argument.
+        After the analysis, send the result back to monitor.
         """
-        kiskadee.logger.debug('Runner PID: {}'.format(os.getpid()))
+        kiskadee.logger.debug('RUNNER PID: {}'.format(os.getpid()))
         while RUNNING:
-            kiskadee.logger.debug('RUNNER: Waiting to dequeue'\
-                                  ' project to analysis...')
+            kiskadee.logger.debug('RUNNER STATE: Idle.')
             self.project = self.queues.dequeue_analysis()
             self.call_analyzers()
 
@@ -42,8 +41,8 @@ class Runner:
                     self.project['fetcher']
                     ).Fetcher()
         except ModuleNotFoundError:
-            kiskadee.logger.debug("Fetcher {} could not be loaded"\
-                    .format(self.project['fetcher'])
+            kiskadee.logger.debug("RUNNER STATE: Fetcher {}\
+                    could not be loaded".format(self.project['fetcher'])
                 )
             return {}
 
@@ -95,19 +94,20 @@ class Runner:
         if source_path is None:
             return None
 
-        kiskadee.logger.debug('ANALYSIS: running {} ...'.format(analyzer))
+        kiskadee.logger.debug('RUNNER STATE: analysing with {} ...'\
+                .format(analyzer))
         try:
             analysis = kiskadee.analyzers.run(analyzer, source_path)
             firehose_report = kiskadee.converter.to_firehose(
                     analysis, analyzer
                 )
             kiskadee.logger.debug(
-                    'ANALYSIS: DONE {} analysis'
+                    'RUNNER STATE: DONE {} analysis'
                     .format(analyzer)
                 )
             return firehose_report
         except Exception as err:
-            kiskadee.logger.debug('RUNNER: could not generate analysis')
+            kiskadee.logger.debug('RUNNER STATE: could not generate analysis')
             kiskadee.logger.debug(err)
             return None
 
@@ -134,7 +134,8 @@ class Runner:
                     dir_to_unpack_source)
             return dir_to_unpack_source
         except Exception as err:
-            kiskadee.logger.debug('Could not unpack project source')
+            kiskadee.logger.debug('RUNNER STATE: Could not unpack'\
+                    'project source')
             kiskadee.logger.debug(err)
             return {}
 

